function R = regularizeET(Q)
%
% REGULARIZE - regularization of singular symmetric matrix.
% 
% Copied from Ellipsoidal Toolbox's private function.  Modified to clear
% some m-lint warnings.

  global ellOptions;

  if ~issymmetric(Q) % A function from YALMIP.
    error('REGULARIZE: matrix must be symmetric.');
  end

  [~, n] = size(Q);
  r      = rank(Q);

  if r < n
    [ U, ~, ~ ] = svd(Q);
    E       = ellOptions.abs_tol * eye(n - r);
    R       = Q + (U * [zeros(r, r) zeros(r, (n-r)); zeros((n-r), r) E] * U');
    R       = 0.5*(R + R');
  else
    R = Q;
  end

  return;
